; *******************************************************
; *                                                     *
; *     Turbo Pascal Runtime Library Version 6.0/7.0    *
; *     Real Longint -> Real Conversion                 *
; *                                                     *
; *     Copyright (C) 1989-1994 Norbert Juffa           *
; *     Copyright (C) 2002-2003 Robert AH Prins         *
; *                                                     *
; *******************************************************

             TITLE   FP48FLT

             .386

CODE         SEGMENT BYTE PUBLIC USE16
             ASSUME  CS:CODE

; Publics

             PUBLIC  RealFloat
             PUBLIC  RFloat

;-------------------------------------------------------------------------------
; RealFloat converts a four byte signed long integer number to the six byte
; TURBO-Pascal floating point format.
;
; INPUT:     DX:AX      longint number
;
; OUTPUT:    DX:BX:AX   real number
;
; DESTROYS:  AX,BX,CH,DX,Flags
;-------------------------------------------------------------------------------

RealFloat    PROC    NEAR

             mov     bx, ax            ; save low word of longint
             or      ax, dx            ; is longint = 0 ?
             jz      $real_zero        ; yes, result is real zero

             mov     ch, 7fh           ; load mask for sign bit
             or      ch, dh            ; extract sign bit (clear carry flag)
             jns     $long_pos         ; no sign bit, number is positive

             neg     dx                ; negate
             neg     bx                ;  long integer

$long_pos:   sbb     dx, 0             ;   in DX:BX
             mov     ax, 0a0h          ; set exponent (assume all bits set)
             jnz     $hiword_set       ; high word of longint not zero

             xchg    dx, bx            ; do a 16-bit left shift on DX:BX
             mov     al, 90h           ; assume last 24 bits in longint set

$hiword_set: test    dh, dh            ; test, wether more than 16 bits set
             jnz     $hibyte_set       ; yes, exponent correct

             sub     al, 8             ; adjust exponent
             or      dh, dl            ; do an
             mov     dl, bh            ;  eight bit
             mov     bh, bl            ;   left shift
             mov     bl, ah            ;    on DX:BX

$hibyte_set: js      $normalized       ; yes, mantissa ready

             INCLUDE ALIGN.ASM

$shift_bit:  dec     ax                ; adjust exp. for left shift of mantissa
             add     bx, bx            ; shift mantissa one
             adc     dx, dx            ;  bit to the left
             jns     $shift_bit        ; until msb of mantissa set

$normalized: and     dh, ch            ; mask out sign bit if necessary

$real_zero:  ret

RealFloat    ENDP

             INCLUDE ALIGN.ASM

RFloat       PROC    FAR

             call    RealFloat         ; perform conversion longint to real
             ret

RFloat       ENDP

             INCLUDE ALIGN.ASM

CODE         ENDS

             END