; *******************************************************
; *                                                     *
; *     Turbo Pascal Runtime Library Version 6.0/7.0    *
; *     Set Load Routine                                *
; *                                                     *
; *     Copyright (C) 1991-1994 Norbert Juffa           *
; *     Copyright (C) 2000-2003 Robert AH Prins         *
; *                                                     *
; *******************************************************

             TITLE   SETHLOD

             .386

CODE         SEGMENT BYTE PUBLIC USE16
             ASSUME  CS:CODE

; Publics

             PUBLIC  ZLoad

;-------------------------------------------------------------------------------
; ZLoad copies a set to an internal set buffer before performing certain set
; operations. The set buffer consists of 32 bytes so it can hold the largest
; possible sets with 256 elements. The routine is passed two properties of the
; set it is to load. One indicates the first buffer byte that will be occupied
; by the set. This parameter is determined by the minimum value that can be
; hold by the set: start = min DIV 8. The second information is the number of
; bytes used to hold the set. This is a function of the minimum and maximum set
; elements: size = max DIV 8 - min DIV 8 + 1.
;
; On entry:  [SP+4]  Set data (MSB = start, LSB = size)
;            [SP+6]  Pointer to set
;            [SP+10] Pointer to 32-byte set buffer
;
; On exit:   [SP]    Pointer to 32-byte set buffer
;-------------------------------------------------------------------------------

ZLoad        PROC    FAR

             cld                       ; auto-increment for string instructions
             mov     bx, sp            ; make new frame pointer
             mov     dx, ds            ; save TURBO data segment
             les     di, ss:[bx + 10]  ; pointer to set buffer
             lds     si, ss:[bx + 6]   ; pointer to loaded set

             mov     cx, 8
             xor     eax, eax          ; load zero
             rep     stosd             ; clear buffer before used bytes
             sub     di, 32            ; restore pointer to set buffer

             mov     bx, ss:[bx + 4]   ; set data
             mov     cl, bh            ; load offset to first byte used by set
             add     di, cx            ; offset of first byte

             mov     cl, bl            ; get number of bytes used by loaded set
             rep     movsb             ; copy bytes used by loaded set to buffer
             mov     ds, dx            ; restore TURBO data segent
             ret     6                 ; leave destination pointer on stack

ZLoad        ENDP

             INCLUDE ALIGN.ASM

CODE         ENDS

             END