; *******************************************************
; *                                                     *
; *     Turbo Pascal Runtime Library Version 6.0/7.0    *
; *     Set Relation Test Routine                       *
; *                                                     *
; *     Copyright (C) 1991-1994 Norbert Juffa           *
; *     Copyright (C) 2000-2003 Robert AH Prins         *
; *                                                     *
; *******************************************************

             TITLE   SETHREL

             .386

CODE         SEGMENT BYTE PUBLIC USE16
             ASSUME  CS:CODE

; Publics

             PUBLIC  ZRelation

;-------------------------------------------------------------------------------
; ZRelation implements the set operators '<=' and '>='. These check if one set
; is included in the other. A set B includes a set C if B = B + C. To implement
; the function, the union of both sets is created on a word per word basis and
; compared to the destination set.
;
; On entry:  [SP+4]  Pointer to first set buffer (= source)
;            [SP+8]  Pointer to second set buffer (= destination)
;
; On exit:   ZF      1, if second set includes first set (dest >= source)
;-------------------------------------------------------------------------------

ZRelation    PROC    FAR

             mov     bx, sp            ; make new frame pointer
             mov     dx, ds            ; save TURBO data segment
             lds     si, ss:[bx + 8]   ; pointer to first set buffer (DS:SI)
             les     di, ss:[bx + 4]   ; pointer to second set buffer (ES:DI)
             mov     cx, 8             ; set buffers consist of 8 dwords each

@@1:         mov     eax, [si]         ; load dword of first set
             add     si, 4             ; increment source counter
             not     eax               ; members not in first set
             add     di, 4             ; increment destination counter
             and     eax, es:[di - 4]  ; members of second set, but not of first
             jne     @@exit            ; there is an element so above is true

             dec     cx
             jnz     @@1

@@exit:      mov     ds, dx            ; restore TURBO data segment
             ret     8                 ; pop both parameters and return

ZRelation    ENDP

             INCLUDE ALIGN.ASM

CODE         ENDS

             END