; *******************************************************
; *                                                     *
; *     Turbo Pascal Runtime Library Version 6.0/7.0    *
; *     Set Store Routine                               *
; *                                                     *
; *     Copyright (C) 1991-1994 Norbert Juffa           *
; *     Copyright (C) 2000-2003 Robert AH Prins         *
; *                                                     *
; *******************************************************

             TITLE   SETHSTO

             .386

CODE         SEGMENT BYTE PUBLIC USE16
             ASSUME  CS:CODE

; Publics

             PUBLIC  ZStore

;-------------------------------------------------------------------------------
; ZStore copies the result of set operations in the set buffer to the output
; set. To determine which bytes from the buffer to copy to the set, the proc is
; passsed set data. This indicates the first used byte of the buffer used by the
; set and set number of bytes it occupies in the buffer.
;
; On entry:  [SP+4]  Set data (MSB = start, LSB = size)
;            [SP+6]  Pointer to output set
;            [SP+10] Pointer to set buffer
;-------------------------------------------------------------------------------

ZStore       PROC FAR

             cld                       ; auto-increment for string instructions
             mov     bx, sp            ; make new frame pointer
             mov     dx, ds            ; save TURBO data segment
             lds     si, ss:[bx + 10]  ; pointer to set buffer (DS:SI)
             les     di, ss:[bx + 6]   ; pointer to output set (ES:DI)
             mov     bx, ss:[bx + 4]   ; set data (MSB = start, LSB = size)
             movzx   cx, bh            ; get offset into set buffer
             add     si, cx            ; point to start of used bytes in buffer
             mov     cl, bl            ; number of bytes used in buffer
             shr     cx, 1             ; number of bytes odd ?
             jnc     @@1               ; no, can store words only

             movsb                     ; move single byte

@@1:         rep     movsw             ; copy from set buffer to output set
             mov     ds, dx            ; restore TURBO data segment
             ret     10                ; pop all parameters and return

ZStore       ENDP

             INCLUDE ALIGN.ASM

CODE         ENDS

             END